/**
* Made by Linus Sylvn 4 anyone to enjoy
* linus.sylven@bredband.net
*/

import java.io.*;
import java.util.*;
import java.sql.*;

class DatToDb{
  RandomAccessFile raf;
  Random ran = new Random();
  DatabaseConection dbcon;
  
  long rafkey, rafprev; 
  int nextLeft, nextRight, size; 
  byte rafval, rafdept;
  
  final int LONG = 8, BYTE = 1, INT = 4, ROW = (LONG*2)+(INT*2)+(BYTE*2);
    
  public static void main(String[] args)throws IOException{ new DatToDb(new File("cube.dat"), 3674160);}
  
  DatToDb(File file, int size)throws IOException{
    this.size = size-1;
    raf = new RandomAccessFile(file, "r");
    //~ dbcon = new DatabaseConection();
    toTextFile(0);
    //~ fillFarest();
  }
  
  void toTextFile(int loops) throws IOException{
    long length = raf.length(), rows = length/ROW;
    System.err.println(length + " bytes = " +rows+" rader");
    raf.seek(0);
    long lastpercentage = 0;      

    Map<String, PrintWriter> textfilemap = new HashMap<String, PrintWriter>(); //  to avoid heap overflow
      for(int i = 1 ; i<8; i++){ 
        String textfile = "cubemap"+i+".txt";
        PrintWriter outputStream  = new PrintWriter(new FileWriter(textfile)); 
        textfilemap.put(textfile, outputStream);
      }
    while(raf.getFilePointer()<raf.length()){
      rafkey = raf.readLong();
      rafval = raf.readByte();
      nextLeft = raf.readInt();
      nextRight = raf.readInt();
      rafdept = raf.readByte();
      rafprev = raf.readLong();
      long percentage = ((loops*1000)/size);  
      if(percentage != lastpercentage){
        lastpercentage = percentage; 
        System.err.println(percentage);
      }
      loops++; 
      (textfilemap.get("cubemap"+(rafkey+"").substring(0,1)+".txt")).println(rafkey+";"+rafval+";"+rafdept+";"+rafprev);
    }
    for(int i = 1 ; i<8; i++){ 
      String textfile = "cubemap"+i+".txt";
      textfilemap.get(textfile).close();
    }
    System.err.println(loops + " of " +rows+" to db");
  }

  
  void fillFarest(){
    try{
      for(int i = 1; i < 8; i++){
        String sql = "SELECT * FROM t_map"+i+" WHERE f_dept = 14";
        PreparedStatement pstm = dbcon.dbConnection.prepareStatement(sql);
        ResultSet rs = pstm.executeQuery();
        while(rs.next()){
          sql = "INSERT INTO t_farest VALUES(?, ?, ?)";
          pstm = dbcon.dbConnection.prepareStatement(sql);
          pstm.setString(1, ""+rs.getString("f_key"));
          pstm.setString(2, ""+rs.getString("f_val"));
          pstm.setString(3, ""+rs.getString("f_dept"));
          pstm.execute();
        }
      }

    }catch(Exception e){
      System.err.println(e);
    };  
  }
  
  // ******** OLD CODE ***********
  
  //~ void writeDat(long loops) throws IOException{
    //~ Map<String, PreparedStatement> sqlmap = new HashMap<String, PreparedStatement>(); //  to avoid heap overflow
    //~ long length = raf.length(), rows = length/ROW;
    //~ System.err.println(length + " bytes = " +rows+" rader");
    //~ raf.seek(0);
    //~ try{
      //~ for(int i = 1 ; i<8; i++){ 
        //~ String sql = "INSERT INTO t_map"+i+" VALUES(? , ?, ?)";
        //~ PreparedStatement pstm = dbcon.dbConnection.prepareStatement(sql); // cannot be reset to many times without getting heap overflow
        //~ sqlmap.put(sql, pstm);
      //~ }
    //~ }catch(Exception e){};
    //~ int lastpercentage = 0;
    //~ long timestamp = System.currentTimeMillis();
    //~ while(raf.getFilePointer()<raf.length()){
      //~ rafkey = raf.readLong();
      //~ rafval = raf.readByte();
      //~ nextLeft = raf.readInt();
      //~ nextRight = raf.readInt();
      //~ rafdept = raf.readByte();
      //~ int percentage = (int)((loops*1000)/size);  
      //~ if(percentage != lastpercentage){
        //~ lastpercentage = percentage; 
        //~ System.err.println(percentage + " millies = "+(System.currentTimeMillis()-timestamp));
        //~ timestamp = System.currentTimeMillis();
      //~ }
      //~ loops++; 
      //~ try{ 
        //~ (sqlmap.get("INSERT INTO t_map"+(rafkey+"").substring(0,1)+" VALUES(? , ?, ?)")).setString(1, ""+rafkey);
        //~ (sqlmap.get("INSERT INTO t_map"+(rafkey+"").substring(0,1)+" VALUES(? , ?, ?)")).setString(2, ""+rafval);
        //~ (sqlmap.get("INSERT INTO t_map"+(rafkey+"").substring(0,1)+" VALUES(? , ?, ?)")).setString(3, ""+rafdept);
        //~ (sqlmap.get("INSERT INTO t_map"+(rafkey+"").substring(0,1)+" VALUES(? , ?, ?)")).execute();
      //~ }catch(Exception e){
        //~ System.err.println("Nr "+ loops-- + " : "+e);
      //~ }
    //~ }
    //~ System.err.println(loops + " of " +rows+" to db");
  //~ }
  
  //~ CubeGlobal getRandomKey()throws IOException{
    //~ int i = ran.nextInt(3674160-1);
    //~ raf.seek(i*ROW);
    //~ rafkey = raf.readLong();
    //~ rafval = raf.readByte();
    //~ nextLeft = raf.readInt();
    //~ nextRight = raf.readInt();
    //~ rafdept = raf.readByte();
    //~ return new CubeGlobal(rafkey, rafval, rafdept);
  //~ }
  
  //~ CubeGlobal getFarestKey(int x)throws IOException{
    //~ int size = 3674160-1;
    //~ x = ran.nextInt(x);
    //~ int i = size-x;
    //~ raf.seek(i*ROW);
    //~ rafkey = raf.readLong();
    //~ rafval = raf.readByte();
    //~ nextLeft = raf.readInt();
    //~ nextRight = raf.readInt();
    //~ rafdept = raf.readByte();
    //~ return new CubeGlobal(rafkey, rafval, rafdept);
  //~ }
    
   //~ CubeGlobal get(long key)throws IOException{
    //~ return get(key, 0);
  //~ }
  
  //~ int looping = 0;
  //~ CubeGlobal get(long key, int seek)throws IOException{
    //~ if(seek==0)looping++;
    //~ raf.seek(seek);
    //~ if(looping == 2 || seek == raf.length()){
      //~ looping=0;
      //~ return new CubeGlobal((long)-1,(byte)-1,(byte)-1);
    //~ }
    //~ raf.seek(seek);
    //~ rafkey = raf.readLong();
    //~ rafval = raf.readByte();
    //~ nextLeft = raf.readInt();
    //~ nextRight = raf.readInt();
    //~ rafdept = raf.readByte();
    //~ if(rafkey == key){
      //~ looping=0;
      //~ return new CubeGlobal(rafkey, rafval, rafdept);
    //~ } else if(rafkey < key){
      //~ return get(key, nextLeft);
    //~ } else if(rafkey > key){
      //~ return get(key, nextRight);
    //~ } else{ 
      //~ throw new IOException("Class DatToDb:get missbuild !!");
    //~ }
  //~ }


}