/**
* Made by Linus Sylvn 4 anyone to enjoy
* linus.sylven@bredband.net
*/

import java.io.*;
import java.util.*;

class LongRTM{
  RandomAccessFile raf;
  Random ran = new Random();
  
  long rafkey, rafPrev; 
  int nextLeft, nextRight; 
  byte rafval, rafdept;
  
  final int LONG = 8, BYTE = 1, INT = 4, ROW = (LONG*2)+(INT*2)+(BYTE*2);
    
public static void main(String[] args){new CalcCube();}

  LongRTM(String fileName, boolean rw)throws IOException{
    File file = new File(fileName);
    file.delete();
    if(rw) raf = new RandomAccessFile(file, "rw");
    else raf = new RandomAccessFile(file, "r");
  }
  
  LongRTM(File file, boolean rw)throws IOException{
    if(rw) raf = new RandomAccessFile(file, "rw");
    else raf = new RandomAccessFile(file, "r");
  }
  
  boolean put(long key, byte val, byte dept, long prev)throws IOException{
    return put(key, val, 0, dept, prev);
  }
  
  private boolean put(long key, byte val, int seek, byte dept, long prev) throws IOException{
    raf.seek(seek);
    if(seek == raf.length()){
      raf.writeLong(key);
      raf.writeByte(val);
      raf.writeInt(0);
      raf.writeInt(0);
      raf.writeByte(dept);
      raf.writeLong(prev);
      return true;
    }
    raf.seek(seek);
    rafkey = raf.readLong();
    rafval = raf.readByte();
    nextLeft = raf.readInt();
    nextRight = raf.readInt();
    rafdept = raf.readByte();
    rafPrev = raf.readLong();
    if(rafkey == key){
      return false;
    } else if(rafkey < key){
      if(nextLeft==0){
        int preMeNextLeftSeek = seek+LONG+BYTE;
        raf.seek(preMeNextLeftSeek);
        nextLeft = (int)raf.length();
        raf.writeInt(nextLeft);
      }
      return put(key, val, nextLeft, dept, prev);
    } else if(rafkey > key){
      if(nextRight==0){
        int preMeNextRightSeek = seek+LONG+BYTE+INT;
        raf.seek(preMeNextRightSeek);
        nextRight = (int)raf.length();
        raf.writeInt(nextRight);
      }
      return put(key, val, nextRight, dept, prev);
    } else{ 
      throw new IOException("Class LongRTM:put missbuild !!");
    }
  }
 
  // *********** old code *********
  //~ CubeGlobal getRandomKey()throws IOException{
    //~ int i = ran.nextInt(3674160-1);
    //~ raf.seek(i*ROW);
    //~ rafkey = raf.readLong();
    //~ rafval = raf.readByte();
    //~ nextLeft = raf.readInt();
    //~ nextRight = raf.readInt();
    //~ rafdept = raf.readByte();
    //~ return new CubeGlobal(rafkey, rafval, rafdept);
  //~ }
  
  //~ CubeGlobal getFarestKey(int x)throws IOException{
    //~ int size = 3674160-1;
    //~ x = ran.nextInt(x);
    //~ int i = size-x;
    //~ raf.seek(i*ROW);
    //~ rafkey = raf.readLong();
    //~ rafval = raf.readByte();
    //~ nextLeft = raf.readInt();
    //~ nextRight = raf.readInt();
    //~ rafdept = raf.readByte();
    //~ return new CubeGlobal(rafkey, rafval, rafdept);
  //~ }
    
   //~ CubeGlobal get(long key)throws IOException{
    //~ return get(key, 0);
  //~ }
  
  //~ int looping = 0;
  //~ CubeGlobal get(long key, int seek)throws IOException{
    //~ if(seek==0)looping++;
    //~ raf.seek(seek);
    //~ if(looping == 2 || seek == raf.length()){
      //~ looping=0;
      //~ return new CubeGlobal((long)-1,(byte)-1,(byte)-1);
    //~ }
    //~ raf.seek(seek);
    //~ rafkey = raf.readLong();
    //~ rafval = raf.readByte();
    //~ nextLeft = raf.readInt();
    //~ nextRight = raf.readInt();
    //~ rafdept = raf.readByte();
    //~ if(rafkey == key){
      //~ looping=0;
      //~ return new CubeGlobal(rafkey, rafval, rafdept);
    //~ } else if(rafkey < key){
      //~ return get(key, nextLeft);
    //~ } else if(rafkey > key){
      //~ return get(key, nextRight);
    //~ } else{ 
      //~ throw new IOException("Class LongRTM:get missbuild !!");
    //~ }
  //~ }

}