/**
* Made by Linus Sylvn 4 anyone to enjoy
* linus.sylven@bredband.net
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import java.net.*;

class Rubik2x2Cube implements Runnable, MouseListener, MouseMotionListener{
  VirtualCube2x2 vicube;
  Camera cam;
  MyJPanel jp;
  static final int MAXDEPTH = 14, CUBES = 8, SQUARES = 6, X = 0, Y = 1, Z = 2;
  final int FREE = 0, FIXING = 1, TWISTING = 2, LOCKED = 4;
  int  size = 105, ofset = 54, camMode = FREE, twistMode = FREE, twist, beginX, beginY, button, lastX, lastY;
  Cube[] cubes = new Cube[CUBES];
  boolean twinvert, solving = false;
  VirtualCubeMapper vcm;
  Thread thread;
  double dPointer0, dPointer1, ang = 0; int mb, layer;
  Square sqr;
  CubeGlobal global = new CubeGlobal();
  JButton jbSolve = new JButton("Solve"), jbRandom = new JButton("Random"), jbFarthest = new JButton("Farthest");
  JProgressBar jpb = new JProgressBar(0, 0, Rubik2x2Cube.MAXDEPTH);
  Solution solution;
  String identity = "Cube2x2:", error = "Connection failure!";

public static void main(String[] p){ new MainFrame.Rubik2x2();}

  Rubik2x2Cube(Color col){
    vicube = new VirtualCube2x2();
    vcm = new VirtualCubeMapper(vicube);
    cubes[0] = new Cube(size, this);
    cubes[1] = new Cube(size, this);
    cubes[2] = new Cube(size, this);
    cubes[3] = new Cube(size, this);
    cubes[4] = new Cube(size, this);
    cubes[5] = new Cube(size, this);
    cubes[6] = new Cube(size, this);
    cubes[7] = new Cube(size, this);
    mapVirtualCubeColorsToMyCubes();
    placeCubes();
    cam = new Camera(700, this);
    cam.setMatrixRotation(-15, -15);
    
    jp = new MyJPanel(cam, col);
    jbSolve.addActionListener(new ButtLiznr());
    jbRandom.addActionListener(new ButtLiznr());
    jbFarthest.addActionListener(new ButtLiznr());
    jpb.setStringPainted(true);
    jpb.setBackground(col);
    jp.addMouseListener(this);
    jp.addMouseMotionListener(this);
  }
  
  String getData(String quiz) {
    jpb.setString("Requesting server information");
    JEditorPane htmlPane = new JEditorPane();
    String result="-2,-2,-2";
    String hela = "", rad;
    boolean goOn = true;
    BufferedReader buff;
    URL url=null;
    //~ String strul = "http://localhost:8040/typeotech/puzzle/server.php?quiz="+quiz;
    String strul = "http://www.typeotech.net/puzzle/server.php?quiz="+quiz;
    try{
      url = new URL(strul);
    } catch (Exception e){
      hela = error;
      goOn = false;
    }
    if(goOn){
      try{
        buff = new BufferedReader(new InputStreamReader(url.openStream()));
          while((rad = buff.readLine()) != null)
            hela+=rad;
        } catch (Exception i){
          jpb.setString(error);
        }//try catch
    }// if goOn 
    if(hela.equals("")){
      hela = error;
      solving = false;
    }
    return hela;
	}
  
  void parseAnswer(String answer, CubeGlobal global) throws NoSuchElementException, NumberFormatException{
    StringTokenizer toker = new StringTokenizer(answer, ":");
    if(toker.countTokens() == 2){
      global.dept = Byte.parseByte(toker.nextToken().trim());
      global.move = Byte.parseByte(toker.nextToken().trim());
    } else {      
      global.state = Long.parseLong(toker.nextToken().trim());
      global.dept = Byte.parseByte(toker.nextToken().trim());
      global.move = Byte.parseByte(toker.nextToken().trim());
    }
  }
    
  void updateProgress(String quiz){
    quiz = identity+quiz;
    String answer="-1:-1:-1";
    if(quiz.equals(identity)) quiz = identity + vicube.getNomalizedState();
    answer = getData(quiz);
    try{
      parseAnswer(answer, global);
      if(global.dept<0){
        jbSolve.setEnabled(false);
        jpb.setString(error);
        solving = false;
      } else {
        jbSolve.setEnabled(true);
        jpb.setValue(global.dept);
        jpb.setString("Moves from completion : "+global.dept);
      }
    }catch(NoSuchElementException nsee){
      jpb.setString(error);
    }catch(NumberFormatException nsee){
      jpb.setString(error);
    }
    jpb.setValue(global.dept);
    jp.repaint();
  }
  
  Square[][] getRotationViewSquares(){
    Square[][] sqrs = new Square[CUBES][SQUARES];
    int dim = getDim(layer);
    for(int i = 0; i<CUBES; i++){
      if(cubes[i].contains(layer)) sqrs[i] = cubes[i].getRotationViewSquares(ang, dim);
      else sqrs[i] = cubes[i].getSquares();
    }
    return sqrs;
  }
  
  Square[][] getSquares(){
    Square[][] sqrs = new Square[CUBES][SQUARES];
    int dim = getDim(layer);
    for(int i = 0; i<CUBES; i++){
      sqrs[i] = cubes[i].getSquares();
    }
    return sqrs;
  }
  
  void placeCubes(){    
    cubes[0].setPos(new Point3d(-ofset, -ofset, ofset));
    cubes[0].setPointer(3, 0, 2, true);
    cubes[0].setPointer(3, 1, 0);
    cubes[0].setPointer(1, 0, 4, true);
    cubes[0].setPointer(1, 1, 0, true);
    cubes[0].setPointer(0, 0, 2);
    cubes[0].setPointer(0, 1, 4);
    
    cubes[1].setPos(new Point3d(ofset, -ofset, ofset));
    cubes[1].setPointer(2, 0, 2);
    cubes[1].setPointer(2, 1, 0, true);
    cubes[1].setPointer(1, 0, 5, true);
    cubes[1].setPointer(1, 1, 0);
    cubes[1].setPointer(0, 0, 2, true);
    cubes[1].setPointer(0, 1, 5);
    
    cubes[2].setPos(new Point3d(ofset, ofset, ofset));
    cubes[2].setPointer(2, 0, 0);
    cubes[2].setPointer(2, 1, 3);
    cubes[2].setPointer(4, 0, 0, true);
    cubes[2].setPointer(4, 1, 5);
    cubes[2].setPointer(0, 0, 5, true);
    cubes[2].setPointer(0, 1, 3, true);
    
    cubes[3].setPos(new Point3d(-ofset, ofset, ofset));
    cubes[3].setPointer(3, 0, 0, true);
    cubes[3].setPointer(3, 1, 3, true);
    cubes[3].setPointer(4, 0, 0);
    cubes[3].setPointer(4, 1, 4);
    cubes[3].setPointer(0, 0, 4, true);
    cubes[3].setPointer(0, 1, 3);
    
    cubes[4].setPos(new Point3d(ofset, -ofset, -ofset));
    cubes[4].setPointer(2, 0, 2, true);
    cubes[4].setPointer(2, 1, 1, true);
    cubes[4].setPointer(1, 0, 1);
    cubes[4].setPointer(1, 1, 5);
    cubes[4].setPointer(5, 0, 2);
    cubes[4].setPointer(5, 1, 5, true);
    
    cubes[5].setPos(new Point3d(ofset, ofset, -ofset));
    cubes[5].setPointer(2, 0, 1);
    cubes[5].setPointer(2, 1, 3, true);
    cubes[5].setPointer(4, 0, 5, true);
    cubes[5].setPointer(4, 1, 1, true);
    cubes[5].setPointer(5, 0, 5);
    cubes[5].setPointer(5, 1, 3);
    
    cubes[6].setPos(new Point3d(-ofset, ofset, -ofset));
    cubes[6].setPointer(4, 0, 4, true);
    cubes[6].setPointer(4, 1, 1);
    cubes[6].setPointer(3, 0, 1, true);
    cubes[6].setPointer(3, 1, 3);
    cubes[6].setPointer(5, 0, 4);
    cubes[6].setPointer(5, 1, 3, true);  
    
    cubes[7].setPos(new Point3d(-ofset, -ofset, -ofset));
    cubes[7].setPointer(1, 0, 1, true);
    cubes[7].setPointer(1, 1, 4);
    cubes[7].setPointer(3, 0, 2);
    cubes[7].setPointer(3, 1, 1);
    cubes[7].setPointer(5, 0, 2, true);
    cubes[7].setPointer(5, 1, 4, true);
  }
  
  void mapVirtualCubeColorsToMyCubes(){
    cubes[0].squares[0].color = vcm.colorMapping(0,0);
    cubes[0].squares[3].color = vcm.colorMapping(0,1);
    cubes[0].squares[1].color = vcm.colorMapping(0,2);

    cubes[1].squares[0].color = vcm.colorMapping(1,0);
    cubes[1].squares[1].color = vcm.colorMapping(1,1);
    cubes[1].squares[2].color = vcm.colorMapping(1,2);

    cubes[2].squares[0].color = vcm.colorMapping(2,0);
    cubes[2].squares[2].color = vcm.colorMapping(2,1);
    cubes[2].squares[4].color = vcm.colorMapping(2,2);
    
    cubes[3].squares[0].color = vcm.colorMapping(3,0);
    cubes[3].squares[4].color = vcm.colorMapping(3,1);
    cubes[3].squares[3].color = vcm.colorMapping(3,2);
    
    cubes[4].squares[2].color = vcm.colorMapping(4,0);
    cubes[4].squares[1].color = vcm.colorMapping(4,1);
    cubes[4].squares[5].color = vcm.colorMapping(4,2);

    cubes[5].squares[2].color = vcm.colorMapping(5,0);
    cubes[5].squares[5].color = vcm.colorMapping(5,1);
    cubes[5].squares[4].color = vcm.colorMapping(5,2);

    cubes[6].squares[3].color = vcm.colorMapping(6,0);
    cubes[6].squares[4].color = vcm.colorMapping(6,1);
    cubes[6].squares[5].color = vcm.colorMapping(6,2);
    
    cubes[7].squares[3].color = vcm.colorMapping(7,0);
    cubes[7].squares[5].color = vcm.colorMapping(7,1);
    cubes[7].squares[1].color = vcm.colorMapping(7,2);
  }
  
  void startTwist(){
    jbRandom.setEnabled(false);
    jbFarthest.setEnabled(false);
    jbSolve.setEnabled(false);
    thread = new Thread(this);
    thread.start();
  }

class Solution{
  CubeGlobal[] solution;
  int pointer;
  
  Solution(CubeGlobal[] solution){
    this.solution = solution;
    pointer = 0;
  }
  
  CubeGlobal getNext(){
    try{ 
      return solution[pointer++];
    }catch(Exception e){
      return null;
    }
  }
  
}

  public void run(){
    int degs = 90;
    for(int i = 1; i<degs+1; i++){
      try{ thread.sleep(10); } catch(Exception e){}
        if(twinvert) ang = Math.toRadians(i) ;
        else ang = -Math.toRadians(i);
      jp.repaint();
    }
    ang=0;
    twistMode = FREE;
    switch(layer){
      case 0 : if(twinvert) vicube.rotBackCW();  else vicube.rotBackCCW();   break;
      case 1 : if(twinvert) vicube.rotFrontCW(); else vicube.rotFrontCCW();  break;
      case 2 : if(twinvert) vicube.rotTopCCW();  else vicube.rotTopCW();     break;
      case 3 : if(twinvert) vicube.rotBottomCW();else vicube.rotBottomCCW(); break;
      case 4 : if(twinvert) vicube.rotLeftCW();  else vicube.rotLeftCCW();   break;
      case 5 : if(twinvert) vicube.rotRightCCW();else vicube.rotRightCW();   break;
    }
    mapVirtualCubeColorsToMyCubes();
    jp.repaint();
    if(solving) {
      solve();
    }else{
      updateProgress("");
      jbRandom.setEnabled(true);
      jbFarthest.setEnabled(true);
      jbSolve.setEnabled(true);
    }
  }
  
  Solution getSolution(){    
    String quiz = identity+";" + vicube.getNomalizedState();
    String answer = getData(quiz);
    StringTokenizer toker = new StringTokenizer(answer, ";");
    int tokens = toker.countTokens();
    CubeGlobal[] ret = new CubeGlobal[tokens];
    for(int t = 0; t < tokens; t++){
      StringTokenizer subToker = new StringTokenizer(toker.nextToken(),":");
      ret[t] = new CubeGlobal(0, 
        Byte.parseByte(subToker.nextToken().trim()),
        Byte.parseByte(subToker.nextToken().trim())
      );
    }
    return new Solution(ret);
  }
  
  public void solve(){
    global = solution.getNext();
    if(global.move > 0){
      switch(global.move){
        case 1 : twinvert = false;  layer = 1; break;
        case 2 : twinvert = true; layer = 1; break;
        case 3 : twinvert = false;  layer = 3; break;
        case 4 : twinvert = true; layer = 3; break;
        case 5 : twinvert = true; layer = 5; break;
        case 6 : twinvert = false;  layer = 5; break;
      }
      startTwist();
    } else {
      solving = false;
      jbRandom.setEnabled(true);
      jbFarthest.setEnabled(true);
      jbSolve.setEnabled(true);
    }
    jpb.setValue(global.dept);
    jpb.setString("Moves from completion : "+global.dept);
  }
    
  public void mousePressed(MouseEvent e){
    button = e.getButton();
    lastX = beginX = e.getX();
    lastY = beginY = e.getY();
    sqr = cam.getClickedSquare(e.getX(), e.getY());
    camMode = FREE;
    if(!solving && (e.getButton() != 3) && (twistMode == FREE) && (sqr != null) && (sqr.p3dLayer[0] != -1)) {
      twistMode = FIXING;
      camMode = LOCKED;
    }
  }
  
  public void mouseDragged(MouseEvent e){
    int currentX = e.getX(), currentY = e.getY();
    if(camMode == FREE ){
      cam.setAngles((lastX - currentX), (lastY - currentY));
      lastX = currentX;
      lastY = currentY;
    } else if(twistMode == FIXING){ 
      int dx = currentX-beginX, dy = currentY-beginY ;
      if( 10 < Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2)) ){
        double cx1 = sqr.center.x+dx;
        double cy1 = sqr.center.y+dy;
        double cx2 = sqr.center.x-dx;
        double cy2 = sqr.center.y-dy;
        int d01 = (int)(Math.sqrt(Math.pow(sqr.corners[4].x-cx1, 2) + Math.pow(sqr.corners[4].y-cy1, 2))), 
            d11 = (int)(Math.sqrt(Math.pow(sqr.corners[5].x-cx1, 2) + Math.pow(sqr.corners[5].y-cy1, 2)));
        int d02 = (int)(Math.sqrt(Math.pow(sqr.corners[4].x-cx2, 2) + Math.pow(sqr.corners[4].y-cy2, 2))), 
            d12 = (int)(Math.sqrt(Math.pow(sqr.corners[5].x-cx2, 2) + Math.pow(sqr.corners[5].y-cy2, 2)));
        int d0 = d02-d01, d1 = d12-d11;
        twistMode=TWISTING;
        boolean who = (Math.abs(d0) > Math.abs(d1));
        if(who){
          layer = sqr.p3dLayer[0];
          if(d0 < 0) twinvert = true;
          else twinvert = false; 
          if(sqr.inv[0]) twinvert = !twinvert;
        } else {
          layer = sqr.p3dLayer[1];
          if(d1 < 0) twinvert = true;
          else twinvert = false; 
          if(sqr.inv[1]) twinvert = !twinvert;
        } // if(Math.abs(twistX-currentX) < Math.abs(twistY-currentY) ){
        startTwist();
      }//if( (int)(twistDx0-dx0) != (int)(twistDx1-dx1) ){
    }
    jp.repaint();
  }
  
  public void mouseReleased(MouseEvent e){
    if(twistMode != TWISTING) twistMode = FREE;
  }
  
class ButtLiznr implements ActionListener, Runnable{
  ActionEvent e;
  
  public void run(){    
    jbFarthest.setEnabled(false);
    jbRandom.setEnabled(false);
    jbSolve.setEnabled(false);
    
    try{
      if(e.	getActionCommand() == "Solve"){
        solving = true;
        cam.remView();
        vicube.normalize();
        mapVirtualCubeColorsToMyCubes();
        cam.adjust();
        jp.repaint();
        solution = getSolution();
        solve();
      }
      
      if(e.getActionCommand() == "Farthest"){
        updateProgress("Farest");
        if(global.state != 0){
          vicube.setState(global.state);
          mapVirtualCubeColorsToMyCubes();
        }
        jp.repaint();
        jbFarthest.setEnabled(true);
        jbRandom.setEnabled(true);
        jbSolve.setEnabled(true);
      }
      
      if(e.getActionCommand() == "Random"){
        updateProgress("Random");
        if(global.state != 0){
          vicube.setState(global.state);
          mapVirtualCubeColorsToMyCubes();
        }
        jp.repaint();
        jbFarthest.setEnabled(true);
        jbRandom.setEnabled(true);
        jbSolve.setEnabled(true);
      }
    }catch(Exception e){}
  }
  
  public void actionPerformed(ActionEvent e){
    this.e = e;
    Thread t = new Thread(this);
    t.start();
  }

} // * class *

  int getDim(int layer){
    int retur = 0;
    switch(layer){
      case 0 : retur = Z; break;
      case 1 : retur = Z; break;
      case 2 : retur = Y; break;
      case 3 : retur = Y; break;
      case 4 : retur = X; break;
      case 5 : retur = X; break;
    }
    return retur;
  }
  
public void mouseMoved(MouseEvent e){}  
public void mouseClicked(MouseEvent e){}
public void mouseEntered(MouseEvent e){}
public void mouseExited(MouseEvent e){} 
}//**class RubCube